﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            const int WIDTH  = 240;
            const int HEIGHT = 240;

            BitmapHelper helper = new BitmapHelper(WIDTH, HEIGHT);

            helper.SetColor(0, 0, 0);

            for(int y = 0; y < 80; y++)
            {
                for(int x = 0; x <= y; x++)
                {
                    helper.SetBlue(x, y, 255);
                }
            }

            for(int x = 0; x < 80; x++)
            {
                for(int y = 80; y < 160; y++)
                {
                    helper.SetGreen(x, y, 255);
                }
            }

            for(int x = 0; x < 80; x++)
            {
                for(int y = 160; y < 240; y++)
                {
                    helper.SetRed(x, y, 255);
                }
            }

            for(int x = 80; x < 160; x++)
            {
                byte color = (byte)((x - 80f) / 80f * 255f);

                for(int y = 0; y < 80; y++)
                {
                    helper.SetBlue(x, y, color);
                }

                for(int y = 80; y < 160; y++)
                {
                    helper.SetGreen(x, y, color);
                }

                for(int y = 160; y < 240; y++)
                {
                    helper.SetRed(x, y, color);
                }
            }

            for(int x = 160; x < 240; x++)
            {
                for(int y = 0; y < 80; y++)
                {
                    helper.SetPixel(x, y, 255, 255, 0, 255);
                }

                for(int y = 80; y < 160; y++)
                {
                    helper.SetPixel(x, y, 0, 255, 255, 255);
                }

                for(int y = 160; y < 240; y++)
                {
                    helper.SetPixel(x, y, 255, 0, 255, 255);
                }
            }

            WriteableBitmap writeableBitmap = helper.GetWriteableBitmap(96, 96);

            Image image = new Image();

            image.Stretch = Stretch.None;
            image.Margin  = new Thickness(0);

            this.mainGrid.Children.Add(image);

            image.Source = writeableBitmap;

            writeableBitmap.Save("sample.bmp");
            writeableBitmap.Save("sample.gif");
            writeableBitmap.Save("sample.jpg");
            writeableBitmap.Save("sample.png");
            writeableBitmap.Save("sample.tif");
            writeableBitmap.Save("sample.wmp");
        }

        #endregion
    }
}